@mrfentmen/syslog-rfc5424-mcp 0.0.0-stage → 1.0.1

This diff represents the content of publicly available package versions that have been released to one of the supported registries. The information contained in this diff is provided for informational purposes only and reflects changes between package versions as they appear in their respective public registries.
package/README.md CHANGED
@@ -1,3 +1,56 @@
1
- # Temporary Holding Version
1
+ # syslog RFC5424 MCP
2
2
 
3
- This version is a temporary placeholder for this package. An operational version to replace this has been submitted for review and is awaiting a staged release.
3
+ syslog MCP: parse RFC5424 and RFC3164 lines, decode PRI/facility/severity, validate timestamps and summarize sources.
4
+
5
+ No network calls. Files are parsed locally and nothing leaves the machine.
6
+
7
+ ## Install
8
+
9
+ ```bash
10
+ npx -y @mrfentmen/syslog-rfc5424-mcp
11
+ ```
12
+
13
+ Or in an MCP client:
14
+
15
+ ```json
16
+ {
17
+ "mcpServers": {
18
+ "syslog-rfc5424-mcp": {
19
+ "command": "npx",
20
+ "args": ["-y", "@mrfentmen/syslog-rfc5424-mcp"]
21
+ }
22
+ }
23
+ }
24
+ ```
25
+
26
+ ## Tools
27
+
28
+ | Tool | What it does |
29
+ |---|---|
30
+ | `detect_files` | Find syslog RFC5424 files in a directory tree. |
31
+ | `read_file` | Read a file or line range. |
32
+ | `write_file` | Write a file, with overwrite protection. |
33
+ | `parse` | Parse into records, fields and metadata. |
34
+ | `validate` | Check structural rules and report issues by line. |
35
+ | `summarize` | Record counts, kinds and document metadata. |
36
+ | `list_records` | List record ids and kinds. |
37
+ | `get_record` | Full fields for one record. |
38
+ | `search` | Plain text or regex search across records. |
39
+ | `stats` | Numeric min/max/mean per field. |
40
+ | `format_reference` | Compact spec reference. |
41
+ | `sample` | A small valid example document. |
42
+ | `diff` | Compare two documents. |
43
+ | `to_json` | Export every record as JSON. |
44
+
45
+ ## Safety
46
+
47
+ This server reads and writes local files. Treat file paths as trusted input.
48
+ Invalid documents are reported, never silently repaired.
49
+
50
+ ## Run locally
51
+
52
+ ```bash
53
+ npm install
54
+ npm run build
55
+ node dist/index.js
56
+ ```
package/dist/core.d.ts ADDED
@@ -0,0 +1,3 @@
1
+ import { McpServer } from "@modelcontextprotocol/sdk/server/mcp.js";
2
+ import type { FormatModule } from "./types.js";
3
+ export declare function registerFormatTools(server: McpServer, format: FormatModule): void;
package/dist/core.js ADDED
@@ -0,0 +1,343 @@
1
+ import { promises as fs } from "node:fs";
2
+ import path from "node:path";
3
+ import { z } from "zod";
4
+ import { errorMessage, fail, text, ToolError } from "./run.js";
5
+ const MAX_INPUT = 4_000_000;
6
+ const SKIP_DIRS = new Set([".git", "node_modules", "dist", "build", ".mcp-build"]);
7
+ async function readInput(input) {
8
+ if (input.path && input.content !== undefined)
9
+ throw new ToolError("Use path or content, not both");
10
+ if (input.content !== undefined) {
11
+ if (input.content.length > MAX_INPUT)
12
+ throw new ToolError(`Input is larger than ${MAX_INPUT} characters`);
13
+ return { body: input.content };
14
+ }
15
+ if (!input.path)
16
+ throw new ToolError("Provide a path or content");
17
+ if (input.path.includes("\0"))
18
+ throw new ToolError("Path contains a null byte");
19
+ const file = path.isAbsolute(input.path) ? input.path : path.resolve(input.cwd ? path.resolve(input.cwd) : process.cwd(), input.path);
20
+ const stat = await fs.stat(file);
21
+ if (!stat.isFile())
22
+ throw new ToolError(`Not a file: ${file}`);
23
+ if (stat.size > MAX_INPUT)
24
+ throw new ToolError(`File is larger than ${MAX_INPUT} bytes`);
25
+ return { body: await fs.readFile(file, "utf8"), file };
26
+ }
27
+ function parseOrThrow(format, body) {
28
+ const parsed = format.parse(body);
29
+ const errors = parsed.issues.filter((issue) => issue.severity === "error");
30
+ if (errors.length > 0) {
31
+ const first = errors.slice(0, 5).map((issue) => (issue.line ? `line ${issue.line}: ${issue.message}` : issue.message));
32
+ throw new ToolError(`${format.displayName} could not be parsed:\n${first.join("\n")}`);
33
+ }
34
+ return parsed;
35
+ }
36
+ function numericStats(records) {
37
+ const out = {};
38
+ for (const record of records) {
39
+ for (const [key, value] of Object.entries(record.fields)) {
40
+ if (typeof value !== "number" || !Number.isFinite(value))
41
+ continue;
42
+ const current = out[key];
43
+ if (!current) {
44
+ out[key] = { count: 1, min: value, max: value, mean: value, sum: value };
45
+ }
46
+ else {
47
+ current.count += 1;
48
+ current.sum += value;
49
+ current.min = Math.min(current.min, value);
50
+ current.max = Math.max(current.max, value);
51
+ current.mean = current.sum / current.count;
52
+ }
53
+ }
54
+ }
55
+ return out;
56
+ }
57
+ function round(value) {
58
+ return Number.isFinite(value) ? Math.round(value * 1000) / 1000 : value;
59
+ }
60
+ export function registerFormatTools(server, format) {
61
+ const sourceArgs = {
62
+ path: z.string().min(1).max(2_000).optional(),
63
+ content: z.string().max(MAX_INPUT).optional(),
64
+ cwd: z.string().min(1).max(2_000).optional(),
65
+ };
66
+ server.tool("detect_files", `Find ${format.displayName} files (${format.extensions.join(", ")}) in a directory tree.`, {
67
+ path: z.string().min(1).max(2_000).default("."),
68
+ maxDepth: z.number().int().min(0).max(8).default(4),
69
+ }, async (a) => {
70
+ try {
71
+ const root = path.resolve(a.path);
72
+ const stat = await fs.stat(root);
73
+ if (!stat.isDirectory())
74
+ throw new ToolError(`Not a directory: ${root}`);
75
+ const found = [];
76
+ let scanned = 0;
77
+ async function walk(dir, depth) {
78
+ if (depth > a.maxDepth || found.length >= 500)
79
+ return;
80
+ let entries;
81
+ try {
82
+ entries = await fs.readdir(dir, { withFileTypes: true });
83
+ }
84
+ catch {
85
+ return;
86
+ }
87
+ for (const entry of entries) {
88
+ if (entry.name.startsWith("."))
89
+ continue;
90
+ const full = path.join(dir, entry.name);
91
+ if (entry.isDirectory()) {
92
+ if (SKIP_DIRS.has(entry.name))
93
+ continue;
94
+ await walk(full, depth + 1);
95
+ continue;
96
+ }
97
+ if (!entry.isFile())
98
+ continue;
99
+ scanned += 1;
100
+ if (!format.extensions.includes(path.extname(entry.name).toLowerCase()))
101
+ continue;
102
+ found.push(path.relative(root, full));
103
+ if (found.length >= 500)
104
+ return;
105
+ }
106
+ }
107
+ await walk(root, 0);
108
+ return text(JSON.stringify({ format: format.displayName, root, filesScanned: scanned, matches: found.length, files: found }, null, 2));
109
+ }
110
+ catch (error) {
111
+ return fail(errorMessage(error));
112
+ }
113
+ });
114
+ server.tool("read_file", `Read a ${format.displayName} file, optionally a line range.`, {
115
+ path: z.string().min(1).max(2_000),
116
+ startLine: z.number().int().min(1).default(1),
117
+ endLine: z.number().int().min(1).optional(),
118
+ cwd: z.string().min(1).max(2_000).optional(),
119
+ }, async (a) => {
120
+ try {
121
+ const { body } = await readInput({ path: a.path, cwd: a.cwd });
122
+ const lines = body.split(/\r?\n/);
123
+ const end = Math.min(a.endLine ?? lines.length, lines.length);
124
+ return text(lines.slice(a.startLine - 1, end).join("\n"));
125
+ }
126
+ catch (error) {
127
+ return fail(errorMessage(error));
128
+ }
129
+ });
130
+ server.tool("write_file", `Write a ${format.displayName} file. Refuses to overwrite unless overwrite is true.`, {
131
+ path: z.string().min(1).max(2_000),
132
+ content: z.string().max(MAX_INPUT),
133
+ overwrite: z.boolean().default(false),
134
+ cwd: z.string().min(1).max(2_000).optional(),
135
+ }, async (a) => {
136
+ try {
137
+ const file = path.isAbsolute(a.path) ? a.path : path.resolve(a.cwd ? path.resolve(a.cwd) : process.cwd(), a.path);
138
+ if (!a.overwrite) {
139
+ const exists = await fs.stat(file).then(() => true).catch(() => false);
140
+ if (exists)
141
+ throw new ToolError(`File already exists: ${file}. Set overwrite=true to replace it.`);
142
+ }
143
+ await fs.mkdir(path.dirname(file), { recursive: true });
144
+ await fs.writeFile(file, a.content, "utf8");
145
+ return text(`Wrote ${Buffer.byteLength(a.content)} bytes to ${file}`);
146
+ }
147
+ catch (error) {
148
+ return fail(errorMessage(error));
149
+ }
150
+ });
151
+ server.tool("parse", `Parse ${format.displayName} into records, fields and document metadata.`, { ...sourceArgs }, async (a) => {
152
+ try {
153
+ const { body, file } = await readInput(a);
154
+ const parsed = parseOrThrow(format, body);
155
+ return text(JSON.stringify({
156
+ file: file ?? null,
157
+ format: parsed.format,
158
+ meta: parsed.meta,
159
+ records: parsed.records.length,
160
+ kinds: parsed.records.reduce((acc, record) => {
161
+ acc[record.kind] = (acc[record.kind] ?? 0) + 1;
162
+ return acc;
163
+ }, {}),
164
+ issues: parsed.issues,
165
+ }, null, 2));
166
+ }
167
+ catch (error) {
168
+ return fail(errorMessage(error));
169
+ }
170
+ });
171
+ server.tool("validate", `Validate ${format.displayName} against its structural rules and report every issue with a line number.`, { ...sourceArgs }, async (a) => {
172
+ try {
173
+ const { body } = await readInput(a);
174
+ const parsed = format.parse(body);
175
+ const errors = parsed.issues.filter((issue) => issue.severity === "error").length;
176
+ const warnings = parsed.issues.length - errors;
177
+ return text(JSON.stringify({
178
+ format: parsed.format,
179
+ valid: errors === 0,
180
+ errors,
181
+ warnings,
182
+ issues: parsed.issues,
183
+ }, null, 2));
184
+ }
185
+ catch (error) {
186
+ return fail(errorMessage(error));
187
+ }
188
+ });
189
+ server.tool("summarize", `Summarize a ${format.displayName} document: metadata, record counts and per-kind totals.`, { ...sourceArgs }, async (a) => {
190
+ try {
191
+ const { body } = await readInput(a);
192
+ const parsed = parseOrThrow(format, body);
193
+ const kinds = parsed.records.reduce((acc, record) => {
194
+ acc[record.kind] = (acc[record.kind] ?? 0) + 1;
195
+ return acc;
196
+ }, {});
197
+ const lines = [
198
+ `${format.displayName} document`,
199
+ `records: ${parsed.records.length}`,
200
+ ...Object.entries(kinds).map(([kind, count]) => ` ${kind}: ${count}`),
201
+ ...Object.entries(parsed.meta).map(([key, value]) => `${key}: ${String(value)}`),
202
+ `issues: ${parsed.issues.length}`,
203
+ ];
204
+ return text(lines.join("\n"));
205
+ }
206
+ catch (error) {
207
+ return fail(errorMessage(error));
208
+ }
209
+ });
210
+ server.tool("list_records", `List ${format.displayName} record ids and kinds, with a limit.`, {
211
+ ...sourceArgs,
212
+ limit: z.number().int().min(1).max(1_000).default(50),
213
+ }, async (a) => {
214
+ try {
215
+ const { body } = await readInput(a);
216
+ const parsed = parseOrThrow(format, body);
217
+ const rows = parsed.records.slice(0, a.limit).map((record) => `${record.kind}\t${record.id}`);
218
+ const rest = parsed.records.length - rows.length;
219
+ return text(rows.join("\n") + (rest > 0 ? `\n... ${rest} more` : ""));
220
+ }
221
+ catch (error) {
222
+ return fail(errorMessage(error));
223
+ }
224
+ });
225
+ server.tool("get_record", `Return one ${format.displayName} record by id, with all parsed fields.`, {
226
+ ...sourceArgs,
227
+ id: z.string().min(1).max(300),
228
+ }, async (a) => {
229
+ try {
230
+ const { body } = await readInput(a);
231
+ const parsed = parseOrThrow(format, body);
232
+ const record = parsed.records.find((item) => item.id === a.id);
233
+ if (!record)
234
+ throw new ToolError(`No record with id ${a.id}. Use list_records to see available ids.`);
235
+ return text(JSON.stringify(record, null, 2));
236
+ }
237
+ catch (error) {
238
+ return fail(errorMessage(error));
239
+ }
240
+ });
241
+ server.tool("search", `Search ${format.displayName} records by plain text or regular expression.`, {
242
+ ...sourceArgs,
243
+ query: z.string().min(1).max(500),
244
+ regex: z.boolean().default(false),
245
+ limit: z.number().int().min(1).max(500).default(50),
246
+ }, async (a) => {
247
+ try {
248
+ const { body } = await readInput(a);
249
+ const parsed = parseOrThrow(format, body);
250
+ let test;
251
+ if (a.regex) {
252
+ let pattern;
253
+ try {
254
+ pattern = new RegExp(a.query, "i");
255
+ }
256
+ catch {
257
+ throw new ToolError(`Invalid regular expression: ${a.query}`);
258
+ }
259
+ test = (value) => pattern.test(value);
260
+ }
261
+ else {
262
+ const needle = a.query.toLowerCase();
263
+ test = (value) => value.toLowerCase().includes(needle);
264
+ }
265
+ const matches = parsed.records.filter((record) => test(`${record.id} ${record.kind} ${JSON.stringify(record.fields)}`));
266
+ const rows = matches.slice(0, a.limit).map((record) => `${record.kind}\t${record.id}`);
267
+ return text(`${matches.length} match(es)\n${rows.join("\n")}`.trim());
268
+ }
269
+ catch (error) {
270
+ return fail(errorMessage(error));
271
+ }
272
+ });
273
+ server.tool("stats", `Numeric statistics for ${format.displayName} fields across all records.`, {
274
+ ...sourceArgs,
275
+ field: z.string().min(1).max(120).optional(),
276
+ }, async (a) => {
277
+ try {
278
+ const { body } = await readInput(a);
279
+ const parsed = parseOrThrow(format, body);
280
+ const stats = numericStats(parsed.records);
281
+ if (a.field) {
282
+ const one = stats[a.field];
283
+ if (!one)
284
+ throw new ToolError(`Field ${a.field} has no numeric values. Numeric fields: ${Object.keys(stats).join(", ") || "none"}`);
285
+ return text(JSON.stringify({ [a.field]: { ...one, mean: round(one.mean) } }, null, 2));
286
+ }
287
+ const rounded = Object.fromEntries(Object.entries(stats).map(([key, value]) => [key, { ...value, mean: round(value.mean) }]));
288
+ return text(JSON.stringify(rounded, null, 2));
289
+ }
290
+ catch (error) {
291
+ return fail(errorMessage(error));
292
+ }
293
+ });
294
+ server.tool("to_json", `Export every parsed ${format.displayName} record as JSON.`, { ...sourceArgs }, async (a) => {
295
+ try {
296
+ const { body, file } = await readInput(a);
297
+ const parsed = parseOrThrow(format, body);
298
+ return text(JSON.stringify({
299
+ file: file ?? null,
300
+ format: parsed.format,
301
+ meta: parsed.meta,
302
+ issues: parsed.issues,
303
+ records: parsed.records,
304
+ }, null, 2));
305
+ }
306
+ catch (error) {
307
+ return fail(errorMessage(error));
308
+ }
309
+ });
310
+ server.tool("diff", `Compare two ${format.displayName} documents: added, removed and changed records.`, {
311
+ leftPath: z.string().min(1).max(2_000).optional(),
312
+ leftContent: z.string().max(MAX_INPUT).optional(),
313
+ rightPath: z.string().min(1).max(2_000).optional(),
314
+ rightContent: z.string().max(MAX_INPUT).optional(),
315
+ cwd: z.string().min(1).max(2_000).optional(),
316
+ }, async (a) => {
317
+ try {
318
+ const left = await readInput({ path: a.leftPath, content: a.leftContent, cwd: a.cwd });
319
+ const right = await readInput({ path: a.rightPath, content: a.rightContent, cwd: a.cwd });
320
+ const before = parseOrThrow(format, left.body);
321
+ const after = parseOrThrow(format, right.body);
322
+ const beforeFields = new Map(before.records.map((record) => [record.id, JSON.stringify(record.fields)]));
323
+ const afterFields = new Map(after.records.map((record) => [record.id, JSON.stringify(record.fields)]));
324
+ const added = [...afterFields.keys()].filter((id) => !beforeFields.has(id));
325
+ const removed = [...beforeFields.keys()].filter((id) => !afterFields.has(id));
326
+ const changed = [...afterFields.keys()].filter((id) => beforeFields.has(id) && beforeFields.get(id) !== afterFields.get(id));
327
+ return text(JSON.stringify({
328
+ format: before.format,
329
+ added: added.length,
330
+ removed: removed.length,
331
+ changed: changed.length,
332
+ unchanged: afterFields.size - added.length - changed.length,
333
+ records: { added, removed, changed },
334
+ issues: { left: before.issues.length, right: after.issues.length },
335
+ }, null, 2));
336
+ }
337
+ catch (error) {
338
+ return fail(errorMessage(error));
339
+ }
340
+ });
341
+ server.tool("format_reference", `Return a compact ${format.displayName} reference: structure, required fields and common pitfalls.`, {}, async () => text(format.reference));
342
+ server.tool("sample", `Return a small but valid ${format.displayName} example document.`, {}, async () => text(format.sample()));
343
+ }
@@ -0,0 +1,2 @@
1
+ import type { FormatModule } from "./types.js";
2
+ export declare const format: FormatModule;
package/dist/format.js ADDED
@@ -0,0 +1,139 @@
1
+ const SEVERITY = ["emerg", "alert", "crit", "err", "warning", "notice", "info", "debug"];
2
+ const FACILITY = [
3
+ "kern", "user", "mail", "daemon", "auth", "syslog", "lpr", "news",
4
+ "uucp", "cron", "authpriv", "ftp", "ntp", "audit", "alert", "clock",
5
+ "local0", "local1", "local2", "local3", "local4", "local5", "local6", "local7",
6
+ ];
7
+ function parsePriorities(pri) {
8
+ const facilityIndex = Math.floor(pri / 8);
9
+ return {
10
+ facility: FACILITY[facilityIndex] ?? `facility${facilityIndex}`,
11
+ severity: SEVERITY[pri % 8] ?? "unknown",
12
+ };
13
+ }
14
+ function parse(text) {
15
+ const issues = [];
16
+ const records = [];
17
+ const bySeverity = {};
18
+ const hosts = new Set();
19
+ let rfc5424 = 0;
20
+ let rfc3164 = 0;
21
+ let unparsed = 0;
22
+ text.split(/\r?\n/).forEach((raw, index) => {
23
+ const number = index + 1;
24
+ const line = raw.trim();
25
+ if (line.length === 0)
26
+ return;
27
+ const priMatch = /^<(\d{1,3})>/.exec(line);
28
+ if (!priMatch) {
29
+ issues.push({ code: "missing-pri", severity: "error", message: "Line does not start with <PRI>", line: number });
30
+ unparsed += 1;
31
+ return;
32
+ }
33
+ const pri = Number(priMatch[1]);
34
+ if (pri < 0 || pri > 191) {
35
+ issues.push({ code: "bad-pri", severity: "error", message: `PRI must be 0-191, got ${pri}`, line: number });
36
+ }
37
+ const { facility, severity } = parsePriorities(pri);
38
+ bySeverity[severity] = (bySeverity[severity] ?? 0) + 1;
39
+ const rest = line.slice(priMatch[0].length);
40
+ let version = null;
41
+ let timestamp = "";
42
+ let host = "";
43
+ let app = "";
44
+ let procId = "";
45
+ let msgId = "";
46
+ let message = "";
47
+ if (/^1 /.test(rest)) {
48
+ version = 1;
49
+ rfc5424 += 1;
50
+ const parts = rest.slice(2).split(" ");
51
+ timestamp = parts[0] ?? "";
52
+ host = parts[1] ?? "";
53
+ app = parts[2] ?? "";
54
+ procId = parts[3] ?? "";
55
+ msgId = parts[4] ?? "";
56
+ const sdStart = rest.indexOf("[");
57
+ if (sdStart === -1 && !rest.includes(" - ")) {
58
+ issues.push({ code: "missing-sd", severity: "warning", message: "RFC5424 line has no structured data or nil value", line: number });
59
+ }
60
+ const msgIndex = rest.indexOf("] ");
61
+ message = msgIndex >= 0 ? rest.slice(msgIndex + 2) : rest.split(" ").slice(6).join(" ");
62
+ if (timestamp !== "-" && !/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d+)?(Z|[+-]\d{2}:\d{2})$/.test(timestamp)) {
63
+ issues.push({ code: "bad-timestamp", severity: "error", message: `Timestamp is not RFC3339: ${timestamp}`, line: number });
64
+ }
65
+ }
66
+ else {
67
+ rfc3164 += 1;
68
+ const match = /^([A-Z][a-z]{2}\s+\d{1,2}\s+\d{2}:\d{2}:\d{2})\s+(\S+)\s+([^:\[]+)(?:\[(\d+)\])?:\s?(.*)$/.exec(rest);
69
+ if (match) {
70
+ timestamp = match[1];
71
+ host = match[2];
72
+ app = match[3].trim();
73
+ procId = match[4] ?? "";
74
+ message = match[5];
75
+ }
76
+ else {
77
+ host = rest.split(/\s+/)[0] ?? "";
78
+ message = rest;
79
+ issues.push({ code: "loose-3164", severity: "warning", message: "RFC3164 header did not match the usual shape", line: number });
80
+ }
81
+ if (!/^[A-Z][a-z]{2}\s+\d{1,2}\s+\d{2}:\d{2}:\d{2}$/.test(timestamp)) {
82
+ issues.push({ code: "bad-timestamp", severity: "warning", message: `RFC3164 timestamp looks wrong: ${timestamp}`, line: number });
83
+ }
84
+ }
85
+ if (host && host !== "-")
86
+ hosts.add(host);
87
+ records.push({
88
+ id: `line-${number}`,
89
+ kind: version === 1 ? "rfc5424" : "rfc3164",
90
+ fields: {
91
+ pri,
92
+ facility,
93
+ severity,
94
+ version,
95
+ timestamp,
96
+ host,
97
+ app,
98
+ procId,
99
+ msgId,
100
+ message,
101
+ line: number,
102
+ },
103
+ });
104
+ });
105
+ return {
106
+ format: "syslog",
107
+ records,
108
+ meta: {
109
+ messages: records.length,
110
+ rfc5424,
111
+ rfc3164,
112
+ unparsed,
113
+ hosts: hosts.size,
114
+ ...Object.fromEntries(Object.entries(bySeverity).map(([key, value]) => [`severity_${key}`, value])),
115
+ },
116
+ issues,
117
+ };
118
+ }
119
+ const reference = [
120
+ "syslog lines",
121
+ "",
122
+ "RFC5424: <PRI>1 TIMESTAMP HOST APP PROCID MSGID STRUCTURED-DATA MSG",
123
+ "RFC3164: <PRI>MMM dd hh:mm:ss HOST TAG: MSG",
124
+ "PRI = facility * 8 + severity. Severity 0 emerg to 7 debug.",
125
+ "Facilities include kern, user, mail, daemon, auth, cron, local0-local7.",
126
+ "A nil timestamp, host or structured data is written as -.",
127
+ ].join("\n");
128
+ export const format = {
129
+ slug: "syslog-rfc5424",
130
+ displayName: "syslog",
131
+ extensions: [".log", ".syslog"],
132
+ description: "Parse RFC5424 and RFC3164 syslog lines, decode PRI and summarize sources.",
133
+ reference,
134
+ parse,
135
+ sample: () => [
136
+ '<34>1 2026-01-01T12:00:00Z host1 app 123 ID47 - message one',
137
+ "<13>Jan 1 12:00:00 host2 cron[45]: message two",
138
+ ].join("\n") + "\n",
139
+ };
@@ -0,0 +1,2 @@
1
+ #!/usr/bin/env node
2
+ export {};
package/dist/index.js ADDED
@@ -0,0 +1,13 @@
1
+ #!/usr/bin/env node
2
+ import { StdioServerTransport } from "@modelcontextprotocol/sdk/server/stdio.js";
3
+ import { createServer } from "./server.js";
4
+ async function main() {
5
+ const server = createServer();
6
+ const transport = new StdioServerTransport();
7
+ await server.connect(transport);
8
+ }
9
+ main().catch((error) => {
10
+ const message = error instanceof Error ? error.message : String(error);
11
+ process.stderr.write(`${message}\n`);
12
+ process.exit(1);
13
+ });
package/dist/run.d.ts ADDED
@@ -0,0 +1,17 @@
1
+ export declare class ToolError extends Error {
2
+ constructor(message: string);
3
+ }
4
+ export declare function errorMessage(error: unknown): string;
5
+ export declare function text(value: string): {
6
+ content: {
7
+ type: "text";
8
+ text: string;
9
+ }[];
10
+ };
11
+ export declare function fail(message: string): {
12
+ isError: boolean;
13
+ content: {
14
+ type: "text";
15
+ text: string;
16
+ }[];
17
+ };
package/dist/run.js ADDED
@@ -0,0 +1,15 @@
1
+ export class ToolError extends Error {
2
+ constructor(message) {
3
+ super(message);
4
+ this.name = "ToolError";
5
+ }
6
+ }
7
+ export function errorMessage(error) {
8
+ return error instanceof Error ? error.message : String(error);
9
+ }
10
+ export function text(value) {
11
+ return { content: [{ type: "text", text: value }] };
12
+ }
13
+ export function fail(message) {
14
+ return { isError: true, content: [{ type: "text", text: message }] };
15
+ }
@@ -0,0 +1,3 @@
1
+ import { McpServer } from "@modelcontextprotocol/sdk/server/mcp.js";
2
+ export declare const VERSION = "1.0.0";
3
+ export declare function createServer(): McpServer;
package/dist/server.js ADDED
@@ -0,0 +1,9 @@
1
+ import { McpServer } from "@modelcontextprotocol/sdk/server/mcp.js";
2
+ import { format } from "./format.js";
3
+ import { registerFormatTools } from "./core.js";
4
+ export const VERSION = "1.0.0";
5
+ export function createServer() {
6
+ const server = new McpServer({ name: `${format.slug}-mcp`, version: VERSION });
7
+ registerFormatTools(server, format);
8
+ return server;
9
+ }
@@ -0,0 +1,31 @@
1
+ export type Severity = "error" | "warning";
2
+ export interface Issue {
3
+ code: string;
4
+ severity: Severity;
5
+ message: string;
6
+ line?: number;
7
+ }
8
+ export interface ParsedRecord {
9
+ id: string;
10
+ kind: string;
11
+ fields: Record<string, string | number | boolean | null>;
12
+ }
13
+ export interface Parsed {
14
+ format: string;
15
+ records: ParsedRecord[];
16
+ meta: Record<string, string | number | boolean | null>;
17
+ issues: Issue[];
18
+ }
19
+ export interface FormatModule {
20
+ slug: string;
21
+ displayName: string;
22
+ extensions: string[];
23
+ description: string;
24
+ reference: string;
25
+ parse(text: string): Parsed;
26
+ sample(): string;
27
+ regressions?: Array<{
28
+ doc: string;
29
+ expectError: string;
30
+ }>;
31
+ }
package/dist/types.js ADDED
@@ -0,0 +1 @@
1
+ export {};
package/package.json CHANGED
@@ -1,6 +1,46 @@
1
1
  {
2
2
  "name": "@mrfentmen/syslog-rfc5424-mcp",
3
- "version": "0.0.0-stage",
4
- "stub": true,
5
- "description": "Temporary package placeholder for staged publishing"
6
- }
3
+ "version": "1.0.1",
4
+ "description": "syslog MCP: parse RFC5424 and RFC3164 lines, decode PRI/facility/severity, validate timestamps and summarize sources.",
5
+ "type": "module",
6
+ "mcpName": "io.github.mrfentmen/syslog-rfc5424-mcp",
7
+ "repository": {
8
+ "type": "git",
9
+ "url": "git+https://github.com/mrfentmen/awesome-servers.git"
10
+ },
11
+ "bin": {
12
+ "syslog-rfc5424-mcp": "./dist/index.js"
13
+ },
14
+ "main": "./dist/index.js",
15
+ "files": [
16
+ "dist",
17
+ "server.json",
18
+ "README.md"
19
+ ],
20
+ "scripts": {
21
+ "build": "tsc -p tsconfig.json",
22
+ "start": "node dist/index.js",
23
+ "test": "npm run build && node --test tests/tools.test.mjs"
24
+ },
25
+ "keywords": [
26
+ "mcp",
27
+ "model-context-protocol",
28
+ "syslog",
29
+ "rfc5424",
30
+ "rfc3164",
31
+ "logging",
32
+ "observability"
33
+ ],
34
+ "license": "MIT",
35
+ "dependencies": {
36
+ "@modelcontextprotocol/sdk": "^1.0.4",
37
+ "zod": "^3.23.8"
38
+ },
39
+ "devDependencies": {
40
+ "@types/node": "^22.0.0",
41
+ "typescript": "^5.6.0"
42
+ },
43
+ "engines": {
44
+ "node": ">=20"
45
+ }
46
+ }
package/server.json ADDED
@@ -0,0 +1,20 @@
1
+ {
2
+ "$schema": "https://static.modelcontextprotocol.io/schemas/2025-12-11/server.schema.json",
3
+ "name": "io.github.mrfentmen/syslog-rfc5424-mcp",
4
+ "description": "syslog MCP: parse RFC5424 and RFC3164 lines, decode PRI/facility/severity, validate timestamps and summarize sources.",
5
+ "repository": {
6
+ "url": "https://github.com/mrfentmen/awesome-servers",
7
+ "source": "github"
8
+ },
9
+ "version": "1.0.1",
10
+ "packages": [
11
+ {
12
+ "registryType": "npm",
13
+ "identifier": "@mrfentmen/syslog-rfc5424-mcp",
14
+ "version": "1.0.1",
15
+ "transport": {
16
+ "type": "stdio"
17
+ }
18
+ }
19
+ ]
20
+ }